"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mockList = mockList;
exports.automockLists = automockLists;
exports.MockList = void 0;

var _graphql = require("graphql");

class MockList {
  constructor(length, mockFunction) {
    this.length = length; // https://stackoverflow.com/questions/54873504/how-to-type-a-generic-function-that-returns-subtypes
    // $FlowFixMe Figure out to parameterize this generic class and default to () => {}

    this.mockFunction = mockFunction ? mockFunction : () => {};
  }

}

exports.MockList = MockList;

function mockList(size, itemMock) {
  return function () {
    return new MockList(size, itemMock);
  };
}

function automockLists(parentType, field, getMocks) {
  const nullableType = (0, _graphql.getNullableType)(field.type);

  if (!(nullableType instanceof _graphql.GraphQLList)) {
    return;
  }

  const nullableOfType = (0, _graphql.getNullableType)(nullableType.ofType);

  if (nullableOfType instanceof _graphql.GraphQLObjectType) {
    return mockList(2);
  } // Little hack so we can call the user-provided automocks.
  // It's not worth making the automock interface more complex just so
  // automock recursive list of scalars.


  const wrapperField = Object.assign({}, field);
  wrapperField.name += '_listOf';
  wrapperField.type = nullableOfType;
  let mock;

  for (let getMock of getMocks) {
    mock = getMock(parentType, wrapperField, getMocks);

    if (mock) {
      break;
    }
  }

  return mockList(2, mock);
}
//# sourceMappingURL=list.js.map